#ifndef FILE_TEXTURE_H
#define FILE_TEXTURE_H

#include "rendering/wrapper/Texture.h"
#include "gaming-core/images/PNGReader.h"

class FileTexture final {
    Texture texture;

public:
    FileTexture(const char* path);

    void bind() const;

private:

    template<int N>
    void read(PNGReader& png) {
        Color<N>* buffer = new Color<N>[png.getBufferSize()];
        if(png.readData(buffer)) {
            return;
        }
        texture.setColorData(png.getWidth(), png.getHeight(), buffer);
        delete[] buffer;
    }
};

#endif